import _Object$defineProperty from 'babel-runtime/core-js/object/define-property';
import _Object$getOwnPropertyDescriptor from 'babel-runtime/core-js/object/get-own-property-descriptor';
import _Object$keys from 'babel-runtime/core-js/object/keys';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';

var _dec, _dec2, _dec3, _desc, _value, _class, _descriptor, _descriptor2;

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;

  _Object$defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import { action, computed } from 'mobx';
import { deserialize as doDeserialize, update as doUpdate, getDefaultModelSchema } from 'serializr';
import DomainModel from './domain-model';

var SchemaAdapter = (_dec = action('deserialize payload of model'), _dec2 = action('update existing model'), _dec3 = action('desrialize array of payload models'), (_class = function () {
  function SchemaAdapter(schema, store) {
    _classCallCheck(this, SchemaAdapter);

    _initDefineProp(this, 'deserialize', _descriptor, this);

    _initDefineProp(this, 'update', _descriptor2, this);

    this.schema = schema;
    this.store = store;
  }

  SchemaAdapter.prototype.serialize = function serialize() {
    throw new Error('not implemented');
  };

  SchemaAdapter.prototype.createEmpty = function createEmpty() {
    var _deserialize;

    return this.deserialize((_deserialize = {}, _deserialize[this.modelIdentifier] = false, _deserialize), true);
  };

  SchemaAdapter.prototype.deserializeArray = function deserializeArray(payload) {
    return payload.map(this.deserialize);
  };

  SchemaAdapter.prototype.getModelSchema = function getModelSchema(model) {
    return getDefaultModelSchema(model);
  };

  _createClass(SchemaAdapter, [{
    key: 'modelIdentifier',
    get: function get() {
      var modelSchema = getDefaultModelSchema(this.schema);
      var idx = null;

      _Object$keys(modelSchema.props).some(function (key) {
        if (modelSchema.props[key].identifier) {
          idx = key;
          return true;
        }

        return false;
      });

      return idx;
    }
  }]);

  return SchemaAdapter;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'deserialize', [_dec], {
  enumerable: true,
  initializer: function initializer() {
    var _this = this;

    return function (payload) {
      var isNew = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var model = doDeserialize(_this.schema, payload);

      if (!_this.modelIdentifier) {
        throw new Error('Can\'t deserialize without identifier() in schema.');
      }

      if (model instanceof DomainModel) {
        model.reload = function () {
          return _this.store.fetchOne(model[_this.modelIdentifier]);
        };
        model.delete = function () {
          return _this.store.deleteItem(model);
        };
        model.getStore = function () {
          return _this.store;
        };
        model.isSaved.set(!isNew);
      }

      return model;
    };
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'update', [_dec2], {
  enumerable: true,
  initializer: function initializer() {
    return function (model, payload) {
      return doUpdate(model, payload);
    };
  }
}), _applyDecoratedDescriptor(_class.prototype, 'modelIdentifier', [computed], _Object$getOwnPropertyDescriptor(_class.prototype, 'modelIdentifier'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'deserializeArray', [_dec3], _Object$getOwnPropertyDescriptor(_class.prototype, 'deserializeArray'), _class.prototype)), _class));
export { SchemaAdapter as default };