'use strict';

exports.__esModule = true;
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _desc, _value, _class;

var _mobx = require('mobx');

var _entitiesAdapter = require('./entities-adapter');

var _entitiesAdapter2 = _interopRequireDefault(_entitiesAdapter);

var _serviceAdapter = require('./service-adapter');

var _serviceAdapter2 = _interopRequireDefault(_serviceAdapter);

var _schemaAdapter = require('./schema-adapter');

var _schemaAdapter2 = _interopRequireDefault(_schemaAdapter);

var _lifecycleHooks = require('./lifecycle-hooks');

var _lifecycleHooks2 = _interopRequireDefault(_lifecycleHooks);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

var _domainModel = require('./domain-model');

var _domainModel2 = _interopRequireDefault(_domainModel);

var _registeredStores = require('./registered-stores');

var _registeredStores2 = _interopRequireDefault(_registeredStores);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var BaseDomainStore = (_class = function () {
  function BaseDomainStore() {
    var _this = this;

    (0, _classCallCheck3.default)(this, BaseDomainStore);
    this.hooks = new _lifecycleHooks2.default(this, _registeredStores2.default);
    this.logger = new _logger2.default(BaseDomainStore.name);
    this.isProcessing = _mobx.observable.box(false);
    this.isListLoading = _mobx.observable.box(false);
    this.isEmpty = _mobx.observable.box(true);

    this.getMap = function () {
      return _this.data.entities;
    };

    this.getOne = function (id) {
      return _this.data.get(id);
    };

    this.has = function (id) {
      return _this.data.has(id);
    };

    this.service = new _serviceAdapter2.default(this.constructor.service);
    this.schema = new _schemaAdapter2.default(this.constructor.modelSchema, this);
    this.data = new _entitiesAdapter2.default(this.schema);

    _registeredStores2.default[this.getStoreName()] = this;
  }

  BaseDomainStore.prototype.storeDidFetchAll = function storeDidFetchAll(_ref) {
    var response = _ref.response;

    return response;
  };

  BaseDomainStore.prototype.storeDidFetchOne = function storeDidFetchOne(_ref2) {
    var response = _ref2.response;

    return response;
  };

  BaseDomainStore.prototype.storeDidCreateNew = function storeDidCreateNew(_ref3) {
    var response = _ref3.response;

    return response;
  };

  BaseDomainStore.prototype.storeDidUpdate = function storeDidUpdate(_ref4) {
    var response = _ref4.response;

    return response;
  };

  BaseDomainStore.prototype.storeDidDelete = function storeDidDelete(_ref5) {
    var response = _ref5.response;

    return response;
  };

  BaseDomainStore.prototype.fetchAll = function () {
    var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
      var _this2 = this;

      var _service,
          response,
          slicedData,
          _args = arguments;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              (0, _mobx.runInAction)(function () {
                _this2.isProcessing.set(true);
                _this2.isListLoading.set(true);
              });

              _context.prev = 1;

              this.hooks.triggerWillFetchAll();

              _context.next = 5;
              return (_service = this.service).fetchAll.apply(_service, _args);

            case 5:
              response = _context.sent;
              _context.next = 8;
              return this.hooks.triggerDidFetchAll(response);

            case 8:
              slicedData = _context.sent;

              if (Array.isArray(slicedData)) {
                _context.next = 11;
                break;
              }

              throw new Error('DidFetchAll return not an array');

            case 11:

              (0, _mobx.runInAction)(function () {
                _this2.data.reset(slicedData);
                _this2.isProcessing.set(false);
                _this2.isEmpty.set(false);
                _this2.isListLoading.set(false);
              });

              return _context.abrupt('return', this.asArray);

            case 15:
              _context.prev = 15;
              _context.t0 = _context['catch'](1);

              this.logger.error(_context.t0);
              this.hooks.triggerFetchAllFailed(_context.t0);
              this.isListLoading.set(false);
              this.isProcessing.set(false);
              throw new Error(_context.t0);

            case 22:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[1, 15]]);
    }));

    function fetchAll() {
      return _ref6.apply(this, arguments);
    }

    return fetchAll;
  }();

  BaseDomainStore.prototype.fetchOne = function () {
    var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(id) {
      var _this3 = this;

      var _service2,
          _len,
          args,
          _key,
          response,
          slicedData,
          model,
          _args2 = arguments;

      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              (0, _mobx.runInAction)(function () {
                _this3.isProcessing.set(true);

                if (_this3.data.has(id)) {
                  var model = _this3.data.get(id);

                  if (model.isReloading) {
                    model.isReloading.set(true);
                  }

                  // TODO: more strict check
                  if (model.isError) {
                    model.isError.set(false);
                  }
                }
              });

              _context2.prev = 1;

              this.hooks.triggerWillFetchOne();

              for (_len = _args2.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                args[_key - 1] = _args2[_key];
              }

              _context2.next = 6;
              return (_service2 = this.service).fetchOne.apply(_service2, [id].concat(args));

            case 6:
              response = _context2.sent;
              _context2.next = 9;
              return this.hooks.triggerDidFetchOne(response);

            case 9:
              slicedData = _context2.sent;

              if (!Array.isArray(slicedData)) {
                _context2.next = 12;
                break;
              }

              throw new Error('DidFetchOne return an array');

            case 12:

              (0, _mobx.runInAction)(function () {
                _this3.data.addOrUpdate(slicedData);
                _this3.isProcessing.set(false);
                _this3.isEmpty.set(false);
              });

              return _context2.abrupt('return', this.getOne(id));

            case 16:
              _context2.prev = 16;
              _context2.t0 = _context2['catch'](1);

              this.logger.error(_context2.t0);

              if (this.data.has(id)) {
                model = this.data.get(id);


                if (model.isError) {
                  model.isError.set(true);
                }
              }

              this.hooks.triggerFetchOneFailed(_context2.t0);

              throw new Error(_context2.t0);

            case 22:
              _context2.prev = 22;

              (0, _mobx.runInAction)(function () {
                var model = _this3.data.get(id);

                if (model.isReloading) {
                  model.isReloading.set(false);
                }

                _this3.isProcessing.set(false);
              });
              return _context2.finish(22);

            case 25:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this, [[1, 16, 22, 25]]);
    }));

    function fetchOne(_x) {
      return _ref7.apply(this, arguments);
    }

    return fetchOne;
  }();

  BaseDomainStore.prototype.deleteItem = function () {
    var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(model) {
      var _this4 = this;

      var response;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              (0, _mobx.runInAction)(function () {
                _this4.isProcessing.set(true);

                if (model instanceof _domainModel2.default) {
                  model.isError.set(false);
                  model.isDeleting.set(true);
                }
              });

              _context3.prev = 1;

              this.hooks.triggerWillDelete(model);
              _context3.next = 5;
              return this.service.deleteItem(model);

            case 5:
              response = _context3.sent;
              _context3.next = 8;
              return this.hooks.triggerDidDelete(response);

            case 8:

              (0, _mobx.runInAction)(function () {
                _this4.data.deleteItem(model);
                _this4.isProcessing.set(false);

                if (model instanceof _domainModel2.default) {
                  model.isSaved.set(true);
                  model.isDeleted.set(true);
                }
              });
              _context3.next = 17;
              break;

            case 11:
              _context3.prev = 11;
              _context3.t0 = _context3['catch'](1);

              this.logger.error(_context3.t0);
              this.hooks.triggerDeleteFailed(_context3.t0);

              (0, _mobx.runInAction)(function () {
                if (model instanceof _domainModel2.default) {
                  model.isError.set(true);
                  model.isDeleted.set(false);
                }
              });

              throw new Error(_context3.t0);

            case 17:
              _context3.prev = 17;

              this.isProcessing.set(false);

              if (model instanceof _domainModel2.default) {
                model.isDeleting.set(false);
              }
              return _context3.finish(17);

            case 21:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, this, [[1, 11, 17, 21]]);
    }));

    function deleteItem(_x2) {
      return _ref8.apply(this, arguments);
    }

    return deleteItem;
  }();

  BaseDomainStore.prototype.updateItem = function () {
    var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(model) {
      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              return _context4.abrupt('return', this.createItem(model, true));

            case 1:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function updateItem(_x3) {
      return _ref9.apply(this, arguments);
    }

    return updateItem;
  }();

  BaseDomainStore.prototype.createItem = function () {
    var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(model) {
      var _this5 = this;

      var isUpdate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var preparedModel, slicedData, response, _response;

      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              preparedModel = void 0;


              (0, _mobx.runInAction)(function () {
                _this5.isProcessing.set(true);

                if (model instanceof _domainModel2.default) {
                  preparedModel = model.serialize();

                  model.isError.set(false);

                  if (!isUpdate) {
                    // Removes ID property from model
                    model.isSaving.set(true);
                    delete preparedModel[_this5.schema.modelIdentifier];
                  } else {
                    model.isUpdating.set(true);
                  }
                } else {
                  // In case when this is just user data
                  preparedModel = model;
                }
              });

              _context5.prev = 2;
              slicedData = void 0;

              if (isUpdate) {
                _context5.next = 14;
                break;
              }

              this.hooks.triggerWillCreateNew();
              _context5.next = 8;
              return this.service.createItem(preparedModel);

            case 8:
              response = _context5.sent;
              _context5.next = 11;
              return this.hooks.triggerDidCreateNew(response);

            case 11:
              slicedData = _context5.sent;
              _context5.next = 21;
              break;

            case 14:
              this.hooks.triggerWillUpdate(preparedModel);
              _context5.next = 17;
              return this.service.updateItem(preparedModel);

            case 17:
              _response = _context5.sent;
              _context5.next = 20;
              return this.hooks.triggerDidUpdate(_response);

            case 20:
              slicedData = _context5.sent;

            case 21:
              if (!Array.isArray(slicedData)) {
                _context5.next = 23;
                break;
              }

              throw new Error('You return array instead of object');

            case 23:

              (0, _mobx.runInAction)(function () {
                _this5.data.addOrUpdate(slicedData);
                _this5.isProcessing.set(false);
                _this5.isEmpty.set(false);

                if (model instanceof _domainModel2.default) {
                  model.isSaved.set(true);
                }
              });
              _context5.next = 32;
              break;

            case 26:
              _context5.prev = 26;
              _context5.t0 = _context5['catch'](2);

              this.logger.error(_context5.t0);

              if (!isUpdate) {
                this.hooks.triggerCreateNewFailed(_context5.t0);
              } else {
                this.hooks.triggerDidUpdateFailed(_context5.t0);
              }

              (0, _mobx.runInAction)(function () {
                if (model instanceof _domainModel2.default) {
                  model.isError.set(true);
                }
              });

              throw new Error(_context5.t0);

            case 32:
              _context5.prev = 32;

              this.isProcessing.set(false);

              if (model instanceof _domainModel2.default) {
                model.isSaving.set(false);
                model.isUpdating.set(false);
              }
              return _context5.finish(32);

            case 36:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, this, [[2, 26, 32, 36]]);
    }));

    function createItem(_x4) {
      return _ref10.apply(this, arguments);
    }

    return createItem;
  }();

  BaseDomainStore.prototype.createEmpty = function createEmpty() {
    return this.schema.createEmpty();
  };

  BaseDomainStore.prototype.getStoreName = function getStoreName() {
    var name = this.constructor.storeName || this.constructor.name;

    if (typeof name === 'function') {
      return name();
    }

    return name;
  };

  (0, _createClass3.default)(BaseDomainStore, [{
    key: 'asArray',
    get: function get() {
      return this.data.array;
    }
  }]);
  return BaseDomainStore;
}(), (_applyDecoratedDescriptor(_class.prototype, 'asArray', [_mobx.computed], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'asArray'), _class.prototype)), _class);
exports.default = BaseDomainStore;
module.exports = exports['default'];