'use strict';

exports.__esModule = true;
exports.default = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dec, _desc, _value, _class, _descriptor;

var _mobx = require('mobx');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  (0, _defineProperty2.default)(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var EntitiesAdapter = (_dec = (0, _mobx.action)('reset models in store'), (_class = function () {
  function EntitiesAdapter(schema) {
    (0, _classCallCheck3.default)(this, EntitiesAdapter);

    _initDefineProp(this, 'entities', _descriptor, this);

    this.schema = schema;
  }

  EntitiesAdapter.prototype.reset = function reset(models) {
    var _this = this;

    var identifier = this.schema.modelIdentifier;
    var newEntities = {};

    models.forEach(function (model) {
      var id = model[identifier];
      var item = _this.get(id);

      if (_this.has(id)) {
        _this.schema.update(item, model);
        newEntities[id] = item;
      } else {
        newEntities[id] = _this.schema.deserialize(model);
      }
    });

    this.entities.replace(newEntities);
  };

  EntitiesAdapter.prototype.addOrUpdate = function addOrUpdate(model) {
    var identifier = this.schema.modelIdentifier;
    var id = model[identifier];
    var item = this.get(id);

    if (this.has(id)) {
      this.schema.update(item, model);
      this.entities.set(id, item);
    } else {
      this.entities.set(id, this.schema.deserialize(model));
    }
  };

  EntitiesAdapter.prototype.deleteItem = function deleteItem(model) {
    var id = model[this.schema.modelIdentifier];
    this.entities.delete(id);
  };

  EntitiesAdapter.prototype.has = function has(id) {
    return this.entities.has(id);
  };

  EntitiesAdapter.prototype.get = function get(id) {
    return this.entities.get(id);
  };

  (0, _createClass3.default)(EntitiesAdapter, [{
    key: 'array',
    get: function get() {
      return this.entities.values();
    }
  }]);
  return EntitiesAdapter;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'entities', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return _mobx.observable.map({});
  }
}), _applyDecoratedDescriptor(_class.prototype, 'reset', [_dec], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'reset'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'get', [_mobx.action], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'get'), _class.prototype)), _class));
exports.default = EntitiesAdapter;
module.exports = exports['default'];