'use strict';

exports.__esModule = true;
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LifecycleHooks = function () {
  function LifecycleHooks(ref, registeredStores) {
    (0, _classCallCheck3.default)(this, LifecycleHooks);

    this.logger = new _logger2.default(LifecycleHooks.name);
    this.ref = ref;
    this.registeredStores = registeredStores;
  }

  LifecycleHooks.prototype.triggerDidFetchAll = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(data) {
      var sliced;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (this.ref.storeDidFetchAll) {
                _context.next = 2;
                break;
              }

              throw new Error('no required LifecycleHook - storeDidFetchAll');

            case 2:
              _context.next = 4;
              return this.ref.storeDidFetchAll({
                response: data, stores: this.registeredStores
              });

            case 4:
              sliced = _context.sent;


              this.logger.debug('Hook storeDidFetchAll triggered', sliced);

              return _context.abrupt('return', sliced);

            case 7:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function triggerDidFetchAll(_x) {
      return _ref.apply(this, arguments);
    }

    return triggerDidFetchAll;
  }();

  LifecycleHooks.prototype.triggerDidFetchOne = function () {
    var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(data) {
      var sliced;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (this.ref.storeDidFetchOne) {
                _context2.next = 2;
                break;
              }

              throw new Error('no required LifecycleHook - storeDidFetchOne');

            case 2:
              _context2.next = 4;
              return this.ref.storeDidFetchOne({
                response: data, stores: this.registeredStores
              });

            case 4:
              sliced = _context2.sent;


              this.logger.debug('Hook storeDidFetchOne triggered', sliced);

              return _context2.abrupt('return', sliced);

            case 7:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function triggerDidFetchOne(_x2) {
      return _ref2.apply(this, arguments);
    }

    return triggerDidFetchOne;
  }();

  LifecycleHooks.prototype.triggerDidCreateNew = function () {
    var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(data) {
      var sliced;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (this.ref.storeDidCreateNew) {
                _context3.next = 2;
                break;
              }

              throw new Error('no required LifecycleHook - storeDidCreateNew');

            case 2:
              _context3.next = 4;
              return this.ref.storeDidCreateNew({
                response: data, stores: this.registeredStores
              });

            case 4:
              sliced = _context3.sent;


              this.logger.debug('Hook storeDidCreateNew triggered', sliced);

              return _context3.abrupt('return', sliced);

            case 7:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function triggerDidCreateNew(_x3) {
      return _ref3.apply(this, arguments);
    }

    return triggerDidCreateNew;
  }();

  LifecycleHooks.prototype.triggerDidUpdate = function () {
    var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(data) {
      var sliced;
      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (this.ref.storeDidUpdate) {
                _context4.next = 2;
                break;
              }

              throw new Error('no required LifecycleHook - storeDidUpdate');

            case 2:
              _context4.next = 4;
              return this.ref.storeDidUpdate({
                response: data, stores: this.registeredStores
              });

            case 4:
              sliced = _context4.sent;


              this.logger.debug('Hook storeDidUpdate triggered', sliced);

              return _context4.abrupt('return', sliced);

            case 7:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function triggerDidUpdate(_x4) {
      return _ref4.apply(this, arguments);
    }

    return triggerDidUpdate;
  }();

  LifecycleHooks.prototype.triggerDidDelete = function () {
    var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(data) {
      var sliced;
      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              if (this.ref.storeDidDelete) {
                _context5.next = 2;
                break;
              }

              throw new Error('no required LifecycleHook - triggerDidDelete');

            case 2:
              _context5.next = 4;
              return this.ref.storeDidDelete({
                response: data, stores: this.registeredStores
              });

            case 4:
              sliced = _context5.sent;


              this.logger.debug('Hook storeDidDelete triggered', sliced);

              return _context5.abrupt('return', sliced);

            case 7:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function triggerDidDelete(_x5) {
      return _ref5.apply(this, arguments);
    }

    return triggerDidDelete;
  }();

  LifecycleHooks.prototype.triggerFetchAllFailed = function triggerFetchAllFailed(error) {
    if (this.ref.storeFetchAllFailed) {
      this.ref.storeFetchAllFailed(error);
      this.logger.debug('Hook storeFetchAllFailed triggered', error);
    }
  };

  LifecycleHooks.prototype.triggerFetchOneFailed = function triggerFetchOneFailed(error) {
    if (this.ref.storeFetchOneFailed) {
      this.ref.storeFetchOneFailed(error);
      this.logger.debug('Hook storeFetchOneFailed triggered', error);
    }
  };

  LifecycleHooks.prototype.triggerCreateNewFailed = function triggerCreateNewFailed(error) {
    if (this.ref.storeCreateNewFailed) {
      this.ref.storeCreateNewFailed(error);
      this.logger.debug('Hook storeCreateNewFailed triggered', error);
    }
  };

  LifecycleHooks.prototype.triggerDeleteNewFailed = function triggerDeleteNewFailed(error) {
    if (this.ref.storeDeleteFailed) {
      this.ref.storeDeleteFailed(error);
      this.logger.debug('Hook storeDeleteFailed triggered', error);
    }
  };

  LifecycleHooks.prototype.triggerDidUpdateFailed = function triggerDidUpdateFailed(error) {
    if (this.ref.storeUpdateFailed) {
      this.ref.storeUpdateFailed(error);
      this.logger.debug('Hook storeUpdateFailed triggered', error);
    }
  };

  LifecycleHooks.prototype.triggerWillFetchAll = function triggerWillFetchAll() {
    if (this.ref.storeWillFetchAll) {
      this.ref.storeWillFetchAll();
      this.logger.debug('Hook storeWillFetchAll triggered');
    }
  };

  LifecycleHooks.prototype.triggerWillFetchOne = function triggerWillFetchOne() {
    if (this.ref.storeWillFetchOne) {
      this.ref.storeWillFetchOne();
      this.logger.debug('Hook storeWillFetchAll triggered');
    }
  };

  LifecycleHooks.prototype.triggerWillCreateNew = function triggerWillCreateNew() {
    if (this.ref.storeWillCreateNew) {
      this.ref.storeWillCreateNew();
      this.logger.debug('Hook storeWillCreateNew triggered');
    }
  };

  LifecycleHooks.prototype.triggerWillUpdate = function triggerWillUpdate() {
    if (this.ref.storeWillUpdate) {
      this.ref.storeWillUpdate();
      this.logger.debug('Hook storeWillUpdate triggered');
    }
  };

  LifecycleHooks.prototype.triggerWillDelete = function triggerWillDelete() {
    if (this.ref.storeWillDelete) {
      this.ref.storeWillDelete();
      this.logger.debug('Hook storeWillDelete triggered');
    }
  };

  return LifecycleHooks;
}();

exports.default = LifecycleHooks;
module.exports = exports['default'];