'use strict';

exports.__esModule = true;
exports.default = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dec, _dec2, _dec3, _desc, _value, _class, _descriptor, _descriptor2;

var _mobx = require('mobx');

var _serializr = require('serializr');

var _domainModel = require('./domain-model');

var _domainModel2 = _interopRequireDefault(_domainModel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  (0, _defineProperty2.default)(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var SchemaAdapter = (_dec = (0, _mobx.action)('deserialize payload of model'), _dec2 = (0, _mobx.action)('update existing model'), _dec3 = (0, _mobx.action)('desrialize array of payload models'), (_class = function () {
  function SchemaAdapter(schema, store) {
    (0, _classCallCheck3.default)(this, SchemaAdapter);

    _initDefineProp(this, 'deserialize', _descriptor, this);

    _initDefineProp(this, 'update', _descriptor2, this);

    this.schema = schema;
    this.store = store;
  }

  SchemaAdapter.prototype.serialize = function serialize() {
    throw new Error('not implemented');
  };

  SchemaAdapter.prototype.createEmpty = function createEmpty() {
    var _deserialize;

    return this.deserialize((_deserialize = {}, _deserialize[this.modelIdentifier] = false, _deserialize), true);
  };

  SchemaAdapter.prototype.deserializeArray = function deserializeArray(payload) {
    return payload.map(this.deserialize);
  };

  SchemaAdapter.prototype.getModelSchema = function getModelSchema(model) {
    return (0, _serializr.getDefaultModelSchema)(model);
  };

  (0, _createClass3.default)(SchemaAdapter, [{
    key: 'modelIdentifier',
    get: function get() {
      var modelSchema = (0, _serializr.getDefaultModelSchema)(this.schema);
      var idx = null;

      (0, _keys2.default)(modelSchema.props).some(function (key) {
        if (modelSchema.props[key].identifier) {
          idx = key;
          return true;
        }

        return false;
      });

      return idx;
    }
  }]);
  return SchemaAdapter;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'deserialize', [_dec], {
  enumerable: true,
  initializer: function initializer() {
    var _this = this;

    return function (payload) {
      var isNew = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var model = (0, _serializr.deserialize)(_this.schema, payload);

      if (!_this.modelIdentifier) {
        throw new Error('Can\'t deserialize without identifier() in schema.');
      }

      if (model instanceof _domainModel2.default) {
        model.reload = function () {
          return _this.store.fetchOne(model[_this.modelIdentifier]);
        };
        model.delete = function () {
          return _this.store.deleteItem(model);
        };
        model.getStore = function () {
          return _this.store;
        };
        model.isSaved.set(!isNew);
      }

      return model;
    };
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'update', [_dec2], {
  enumerable: true,
  initializer: function initializer() {
    return function (model, payload) {
      return (0, _serializr.update)(model, payload);
    };
  }
}), _applyDecoratedDescriptor(_class.prototype, 'modelIdentifier', [_mobx.computed], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'modelIdentifier'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'deserializeArray', [_dec3], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'deserializeArray'), _class.prototype)), _class));
exports.default = SchemaAdapter;
module.exports = exports['default'];